﻿const mainlink="https://restapi20190624033927.azurewebsites.net/api"; //core part of the webservice link 
const codestring="?code=7XMT2o8rqHbaViy2geq9X4rYFwI5xYnNav1bGFcchdlBhKXR5PvcDA=="	//webservice code, append to end of link
const blog_id = document.getElementById("storage").getAttribute("data-variable-two"); //get blog_name
var measure_id = document.getElementById("storage").getAttribute("data-variable-four"); //get MeasureId
var url = mainlink+"/ESZTrend/"+blog_id+codestring;
var url1 = mainlink+"/ESZTrend/"+blog_id+"/1"+codestring;
var url2 = mainlink+"/ESZTrend/"+blog_id+"/"+measure_id+codestring;

function addAxesAndLegend (svg, xAxis, yAxis, margin, chartWidth, chartHeight) {
  var legendWidth  = 200,
      legendHeight = 100;

  // Clipping, um sicherzustellen, dass hinter der Legende nichts angezeigt wird
  svg.append('clipPath')
    .attr('id', 'axes-clip')
    .append('polygon')
      .attr('points', (-margin.left)                 + ',' + (-margin.top)                 + ' ' +
                      (chartWidth - legendWidth - 1) + ',' + (-margin.top)                 + ' ' +
                      (chartWidth - legendWidth - 1) + ',' + legendHeight                  + ' ' +
                      (chartWidth + margin.right)    + ',' + legendHeight                  + ' ' +
                      (chartWidth + margin.right)    + ',' + (chartHeight + margin.bottom) + ' ' +
                      (-margin.left)                 + ',' + (chartHeight + margin.bottom));

  var axes = svg.append('g')
    .attr('clip-path', 'url(#axes-clip)');

  axes.append('g')
    .attr('class', 'x axis')
    .attr('transform', 'translate(0,' + chartHeight + ')')
    .call(xAxis);

  axes.append('g')
    .attr('class', 'y axis')
    .call(yAxis)
    .append('text')
      .attr('transform', 'rotate(-90)')
      .attr('y', 6)
      .attr('dy', '.71em')
      .style('text-anchor', 'end')
      .text('Leistung (kW)');

  var legend = svg.append('g')
    .attr('class', 'legend')
    .attr('transform', 'translate(' + (chartWidth - legendWidth) + ', 0)');

  legend.append('rect')
    .attr('class', 'legend-bg')
    .attr('width',  legendWidth)
    .attr('height', legendHeight);

//  legend.append('rect')
//    .attr('class', 'outer')
//    .attr('width',  75)
//    .attr('height', 20)
//    .attr('x', 10)
//    .attr('y', 10);

//  legend.append('text')
//    .attr('x', 115)
//    .attr('y', 25)
//    .text('5% - 95%');

//  legend.append('rect')
//    .attr('class', 'inner')
//    .attr('width',  75)
//    .attr('height', 20)
//    .attr('x', 10)
//    .attr('y', 40);

  legend.append('path')
    .attr('class', 'baseline')
    .attr('d', 'M10,50L55,50');

  legend.append('text')
    .attr('x', 115)
    .attr('y', 55)
    .text('Baseline');

  legend.append('path')
    .attr('class', 'median-line')
    .attr('d', 'M10,80L85,80');

  legend.append('text')
    .attr('x', 115)
    .attr('y', 85)
    .text('Verbrauch');
}

function drawPaths (svg, data, x, y) {
  var upperOuterArea = d3.svg.area()
    .interpolate('basis')
    .x (function (d) { return x(d.date) || 1; })
    .y0(function (d) { return y(d.pct95); });
//    .y1(function (d) { return y(d.pct75); });

  var upperInnerArea = d3.svg.area()
    .interpolate('basis')
    .x (function (d) { return x(d.date) || 1; })
    .y0(function (d) { return y(d.pct75); });
//    .y1(function (d) { return y(d.pct50); });

  var baseLine = d3.svg.line()
    .interpolate('basis')
    .x(function (d) { return x(d.date); })
    .y(function (d) { return y(d.pct75); });

  var medianLine = d3.svg.line()
    .interpolate('basis')
    .x(function (d) { return x(d.date); })
    .y(function (d) { return y(d.pct50); });

  var lowerInnerArea = d3.svg.area()
    .interpolate('basis')
    .x (function (d) { return x(d.date) || 1; })
    .y0(function (d) { return y(d.pct50); })
    .y1(function (d) { return y(d.pct25); });

  var lowerOuterArea = d3.svg.area()
    .interpolate('basis')
    .x (function (d) { return x(d.date) || 1; })
    .y0(function (d) { return y(d.pct25); })
    .y1(function (d) { return y(d.pct05); });

  svg.datum(data);

//  svg.append('path')
//    .attr('class', 'area upper outer')
//    .attr('d', upperOuterArea)
//    .attr('clip-path', 'url(#rect-clip)');

//  svg.append('path')
//    .attr('class', 'area lower outer')
//    .attr('d', lowerOuterArea)
//    .attr('clip-path', 'url(#rect-clip)');

//  svg.append('path')
//    .attr('class', 'area upper inner')
//    .attr('d', upperInnerArea)
//    .attr('clip-path', 'url(#rect-clip)');

//  svg.append('path')
//    .attr('class', 'area lower inner')
//    .attr('d', lowerInnerArea)
//    .attr('clip-path', 'url(#rect-clip)');

  svg.append('path')
    .attr('class', 'baseline')
    .attr('d', baseLine)
    .attr('clip-path', 'url(#rect-clip)');

  svg.append('path')
    .attr('class', 'median-line')
    .attr('d', medianLine)
    .attr('clip-path', 'url(#rect-clip)');
}

function addMarker (marker, svg, chartHeight, x, nummer) {
  var radius = 32,
      xPos = x(marker.date) - radius - 3,
      yPosStart = chartHeight - radius - 3,
      yPosEnd = ((marker.type == 'WTV' || marker.type == 'Leck-') ? 160 : 80) + radius - 3;

var markerG;

if (measure_id <= 0) {
  markerG = svg.append('g')
//    .attr('class', 'marker '+marker.type.toLowerCase())
    .attr('class', 'marker client')
    .attr('transform', 'translate(' + xPos + ', ' + yPosStart + ')')
    .attr('opacity', 0)
    .on('click', function(d, i) { window.location.replace('../einspartrends?MeasureId='+(nummer+1).toString())})
    .on({
      "mouseover": function(d) {
        d3.select(this).style("cursor", "pointer"); 
      },
      "mouseout": function(d) {
        d3.select(this).style("cursor", "default"); 
      }
    });
}
else {
  markerG = svg.append('g')
//    .attr('class', 'marker '+marker.type.toLowerCase())
    .attr('class', 'marker client')
    .attr('transform', 'translate(' + xPos + ', ' + yPosStart + ')')
    .attr('opacity', 0);

}

  markerG.transition()
    .duration(1000)
    .attr('transform', 'translate(' + xPos + ', ' + yPosEnd + ')')
    .attr('opacity', 1);

  markerG.append('path')
    .attr('d', 'M' + radius + ',' + (chartHeight-yPosStart) + 'L' + radius + ',' + (chartHeight-yPosStart))
    .transition()
      .duration(1000)
      .attr('d', 'M' + radius + ',' + (chartHeight-yPosEnd) + 'L' + radius + ',' + (radius*2));

  markerG.append('circle')
    .attr('class', 'marker-bg')
    .attr('cx', radius)
    .attr('cy', radius)
    .attr('r', radius);

  markerG.append('text')
    .attr('x', radius)
    .attr('y', radius*0.9)
    .text(marker.type);

  markerG.append('text')
    .attr('x', radius)
    .attr('y', radius*1.5)
    .text(marker.version);
}

function startTransitions (svg, chartWidth, chartHeight, rectClip, markers, x) {
  rectClip.transition()
    .duration(1000*markers.length)
    .attr('width', chartWidth);

  markers.forEach(function (marker, i) {
    setTimeout(function () {
      addMarker(marker, svg, chartHeight, x, i);
    }, 1000 + 500*i);
  });
}

function makeChart (data, markers) {
  var svgWidth  = 1300,
      svgHeight = 500,
      margin = { top: 20, right: 20, bottom: 40, left: 40 },
      chartWidth  = svgWidth  - margin.left - margin.right,
      chartHeight = svgHeight - margin.top  - margin.bottom;

  var x = d3.time.scale().range([0, chartWidth])
            .domain(d3.extent(data, function (d) { return d.date; })),
      y = d3.scale.linear().range([chartHeight, 0])
            .domain([0, d3.max(data, function (d) { return d.pct95; })]);

  var xAxis = d3.svg.axis().scale(x).orient('bottom')
                .innerTickSize(-chartHeight).outerTickSize(0).tickPadding(10),
      yAxis = d3.svg.axis().scale(y).orient('left')
                .innerTickSize(-chartWidth).outerTickSize(0).tickPadding(10);

 //--bffft- var svg = d3.select('body').append('svg') das svg in das #chartdiv zeichnen statt in body
  var svg = d3.select('#chartdiv').append('svg')
  //  .attr('top',  0)
  //  .attr('width',  svgWidth)
  //  .attr('height', svgHeight)
  //---bffft- mit viewBox wird das chart responsiv
  .attr("viewBox", "0 0 1300 500")
    .append('g')
  //    .attr('transform', 'translate(' + margin.left + ',' + margin.top + ')');

  // clipping to start chart hidden and slide it in later
  var rectClip = svg.append('clipPath')
    .attr('id', 'rect-clip')
    .append('rect')
      .attr('width', 0)
      .attr('height', chartHeight);

  addAxesAndLegend(svg, xAxis, yAxis, margin, chartWidth, chartHeight);
  drawPaths(svg, data, x, y);
  startTransitions(svg, chartWidth, chartHeight, rectClip, markers, x);
}

            function NEUchangeData() {
                
                var rects = d3.select(".svg_canvas")
                    .selectAll("rect")
                    .data(dataJSON2);

                // UPDATE
                rects
                    .attr("class","my_element_updated");

                // ENTER
                rects
                    .enter()
                    .append("rect")
                    .attr("x", "200")
                    .attr("y", function(d,i){
                        return (i+1)*20;
                    })
                    .attr("width", function(d){
                        return d.width;
                    })
                    .attr("height", "20")
                    .attr("class", "my_element")
                    .style("fill", function(d,i){
                        return d.color;
                    });

                // EXIT
                rects.exit().remove();
            }


function changeData() {
  url2 = mainlink+"/ESZTrend/"+blog_id+"/"+measure_id+codestring;

  d3.json(url2, function (error, rawData) {
  if (error) {
    console.error(error);
    return;
  }

  var data = rawData.map(function (d) {
    return {
      date:  parseDate(d.date),
//      pct05: d.pct05 / 1000,
//      pct25: d.pct25 / 1000,
      pct50: d.pct50 / 1000,
      pct75: d.pct75 / 1000,
     pct95: d.pct95 / 1000
    };
  });

  d3.json('../../wp-content/plugins/manageE_esz-trend/markers.json?nocache=' + (new Date()).getTime(), function (error, markerData) {
    if (error) {
      console.error(error);
      return;
    }

    var markers = markerData.map(function (marker) {
      return {
        date: parseDate(marker.date),
        type: marker.type,
        version: marker.version
      };
    });

    makeChart(data, markers);
  });
                
}
)}



url3 = mainlink+"/Massnahmen/"+blog_id+codestring;

var interval = 4; // 1:Tag(15min), 2:Tag(1h), 3:Woche(7T), 4:Monat, 5:Jahr
var periode = 0;

let dropdown = $('#datas');
var messung = document.getElementById('messung');
dropdown.empty();
// Populate dropdown with list of nodes:
dropdown.append('<option value=0>[ALLE]</option>');
if (parseInt(measure_id) <= 0) {
//dropdown.append('<option selected="true" disabled>[ALLE]</option>');
$.getJSON(url3, function (data3) {
  $.each(data3, function (key, entry) {
    dropdown.append($('<option></option>').attr('value', entry.Massnahme).text(entry.Bezeichnung));
  })
})  
measure_id = "0";


}
else {
$.getJSON(url3, function (data3) {
  $.each(data3, function (key, entry) {
	if (entry.Massnahme == parseInt(measure_id)) {
    		dropdown.append($('<option selected=true></option>').attr('value', entry.Massnahme).text(entry.Bezeichnung));
		//messung.text = entry.Bezeichnung;
	}
	else {
	    dropdown.append($('<option></option>').attr('value', entry.Massnahme).text(entry.Bezeichnung));
	}
  })

})  }
//dropdown.style.visibility = 'hidden';









url1 = mainlink+"/ESZTrend/"+blog_id+"/"+measure_id+codestring;

var parseDate  = d3.time.format('%Y-%m-%d').parse;
//d3.json('../../wp-content/plugins/manageE_esz-trend/data.json', function (error, rawData) {
//d3.json('https://restapi20190624033927.azurewebsites.net/api/ESZTrend/13?code=ap/WMaA11Pre4z3FI0lI3/clMcSZWG4HwN4iAc7fKwzeGFyVk11gLw==', function (error, rawData) {
d3.json(url1, function (error, rawData) {
  if (error) {
    console.error(error);
    return;
  }

  var data = rawData.map(function (d) {
    return {
      date:  parseDate(d.date),
//      pct05: d.pct05 / 1000,
//      pct25: d.pct25 / 1000,
      pct50: d.pct50 / 1000,
      pct75: d.pct75 / 1000,
     pct95: d.pct95 / 1000
    };
  });

var markerstring = "";
if (measure_id == 1) { 
  markerstring  = '../../wp-content/plugins/manageE_esz-trend/markers1.json?nocache=' + (new Date()).getTime();
}
else if (measure_id == 2) { 
  markerstring  = '../../wp-content/plugins/manageE_esz-trend/markers2.json?nocache=' + (new Date()).getTime();
}
else if (measure_id == 3) { 
  markerstring  = '../../wp-content/plugins/manageE_esz-trend/markers3.json?nocache=' + (new Date()).getTime();
}
else if (measure_id == 4) { 
  markerstring  = '../../wp-content/plugins/manageE_esz-trend/markers4.json?nocache=' + (new Date()).getTime();
}
else if (measure_id == 5) { 
  markerstring  = '../../wp-content/plugins/manageE_esz-trend/markers5.json?nocache=' + (new Date()).getTime();
}
else if (measure_id == 6) { 
  markerstring  = '../../wp-content/plugins/manageE_esz-trend/markers6.json?nocache=' + (new Date()).getTime();
}
else { 
  markerstring  = '../../wp-content/plugins/manageE_esz-trend/markers.json?nocache=' + (new Date()).getTime();
}
 
  d3.json(markerstring, function (error, markerData) {
    if (error) {
      console.error(error);
      return;
    }





    var markers = markerData.map(function (marker) {
      return {
        date: parseDate(marker.date),
        type: marker.type,
        version: marker.version
      };
    });
	
    makeChart(data, markers);
	
  });
});
